/*****************************************************************************
*
* Atmel Corporation
*
* File              : main.c
* Compiler          : IAR EWAAVR 2.28a/3.10a
* Revision          : $Revision: 1.1 $
* Date              : $Date: 29. april 2004 15:57:40 $
* Updated by        : $Author: ltwa $
*
* Support mail      : avr@atmel.com
*
* Supported devices : All devices with internal RC oscillator and 1 timer.
*
* AppNote           : AVR054 Synchronization of the internal RC oscillator based on the LIN method
*
* Description       : Program entry point and sleep function.
*
* 
****************************************************************************/

#include <inavr.h>
#include <ioavr.h>
#include "online_synch.h"


unsigned char breakDetected;
unsigned char synchState;
unsigned char calStep;


void main(void)
{  
    // For testing only:
    // Set up Timer/counter1 to generate a frequency of fclk/2 on OC2
    SET_OC1A_DIRECTION();
    OCR1A = 0x00;
    TCCR1A = (1 << COM1A0);
    TCCR1B = (1 << WGM12) | (1 << CS10);
    
    
    Initialize_Synchronization();
    
    __enable_interrupt();
    for(;;)
    {
    }
}


void sleep()
{
    // Set INT0 to trigger on low level.
    __disable_interrupt();
    EXT_INT_SENSE_CTRL_REGISTER &= ~((1 << ISC01) | (1 << ISC00));
    EXT_INT_FLAG_REGISTER |= (1 << INTF0);
    EXT_INT_MASK_REGISTER |= (1 << INT0);
    
    #if defined(SM2)
    // Set sleep  mode.
    MCUCR |= ((1 << SE) | (1 << SM0) | (0 << SM0) | (0 << SM2));
    #else
    MCUCR |= ((1 << SE) | (1 << SM0) | (0 << SM0));
    #endif
    
    // Make sure that interrupts are enabled, and go to sleep.
    __enable_interrupt();
    __sleep();
}
